{ -------------------------------------------------------------------- *
*                                                                      *
*   3333   CCCC      CCCC  OOOO  N     N  CCCC  EEEEE  PPPP  TTTTTTT   *
*       3 C         C     O    O NN    N C      E      P   P    T      *
*       3 C         C     O    O N N   N C      E      P   P    T      *
*   3333  C         C     O    O N  N  N C      EEEE   PPPP     T      *
*       3 C         C     O    O N   N N C      E      P        T      *
*       3 C         C     O    O N    NN C      E      P        T      *
*   3333   CCCC      CCCC  OOOO  N     N  CCCC  EEEEE  P        T      *
*                                                                      *
* UNITE D'INTERFACE POUR DLL/Win32 Module TC/USB-18A (8E/4S/C/E/S Ana) *
*                                                                      *
* (c)2010 3C CONCEPT S.A.S                Version 1.00 du 11/02/2009    *
* 1.00: 11/02/2009
* 1.01:  05/07/2010: DB: correction description fonction "bit_input"                                                                    *
* -------------------------------------------------------------------- *
* Fichier a inclure dans le programme principal pour utiliser TCUSB18A.DLL
* A utiliser avec la directive $INCLUDE TCUSB18A.INC
*}

const
  maxmodule   = 8;   { N des modules de 1  8 }

{ Codes d'erreur gnrs par les fonctions de base ci-dessous,
  les fonctions oprant sur bit (BITINPUT, BITOUTPUT, BITREADBACK) ne retournent
  pas de code erreur }

  erNoError   = 0;   { OK }
  erNumSerie  = 1;   { Numero de serie incorrect }
  erModule    = 2;   { N de module incorrect }
  erNoModule  = 3;   { Pas de module dtect }
  erNoInit    = 4;   { Module non initialis }
  erWrite     = 5;
  erRead      = 6;
  erClose     = 7;   { erreur  la fermeture }
  erConsigne  = 8;   { erreur consigne analogique }
  erVoie      = 9;   { erreur voie analogique }

{*************************************************************************************}
{********************** OPERATIONS DE BASE ******************* *******************}
{*************************************************************************************}

function TCUSB18A_Refresh(NModule:integer):integer;stdcall;external 'TCUSB18A.DLL';
{ Actualise les donnes (Entres + Sorties + Compteurs+E/S analogique) du module indiqu
  A utiliser apres toute fonction sur les sorties et avant toute fonction sur les entres et compteurs
  un code erreur correspond  la valeur retourne par la fonction }

function TCUSB18A_GetParams(NModule: integer):integer;stdcall;external 'TCUSB18A.DLL';
function TCUSB18A_GetConfig(NModule:integer;voie:integer;var Gain:single;var offset:single):integer;stdcall; external 'TCUSB18A.DLL';
function TCUSB18A_SetParams(NModule: integer):integer;stdcall;external 'TCUSB18A.DLL';
function TCUSB18A_ModifyParams(NModule: integer;Voie: byte; A_Gain, A_Offset: single):integer;stdcall;external 'TCUSB18A.DLL';


function TCUSB18A_Open(NModule:integer;var NumSerie:PChar):integer;stdcall;external 'TCUSB18A.DLL';
{ Initialise le driver, affecte le numro de srie du module au numro de module
  spcifi (1  8) et remet  0 les sorties. si numro de srie est vide alors ouvre le premier module dtect.
  A utiliser avant tout autre appel a une fonction TCUSB18A_xxx
  Fermer la session par TCUSB18A_Close
  un code erreur correspond  la valeur retourne par la fonction }

  
function TCUSB18A_OpenN(NModule:integer;var NumSerie:DWord):integer;stdcall;external 'TCUSB18A.DLL';
{ Initialise le driver, affecte le numro de srie du module au numro de module
  spcifi (1  8) et remet  0 les sorties. si numro de srie=0 alors ouvre le premier module dtect.
  A utiliser avant tout autre appel a une fonction TCUSB18A_xxx
  Fermer la session par TCUSB18A_Close
  un code erreur correspond  la valeur retourne par la fonction }

  
function TCUSB18A_Close(NModule:integer):integer;stdcall;external 'TCUSB18A.DLL';
{ Termine la session et ferme le driver (indispensable  la fin du programme)
  un code erreur correspond  la valeur retourne par la fonction }

  
function TCUSB18A_Input(NModule:integer;var Data:DWord):integer;stdcall;external 'TCUSB18A.DLL';
{ Lecture des entres du module indiqu, le retour se fait par parametre dans la variable Data (32 bits)
  un code erreur correspond  la valeur retourne par la fonction }


function TCUSB18A_Output(NModule:integer;Data:Byte):integer;stdcall;external 'TCUSB18A.DLL';
{ Envoi sur les sorties du module indiqu la valeur contenue dans la variable Data (8 bits),
  un code erreur correspond  la valeur retourne par la fonction }

  
{*************************************************************************************}
{********************** OPERATIONS SUR BITS ******************************************}
{*************************************************************************************}

function TCUSB18A_BitInput(NModule,Entree:integer;var Data:byte):integer;stdcall;external 'TCUSB18A.DLL';
{ Lecture de l'tat d'une entre (1  8) du module spcifi
  un code erreur correspond  la valeur retourne par la fonction }


function TCUSB18A_BitOutput(NModule,Sortie,etat:integer):integer;stdcall;external 'TCUSB18A.DLL';
{ Place la sortie (1  4) du module spcifie dans l'tat indiqu (0 ou 1)
  un code erreur correspond  la valeur retourne par la fonction }


function TCUSB18A_BitReadBack(NModule,Sortie:integer;var Data:byte):integer;stdcall;external 'TCUSB18A.DLL';
{ Relecture de l'tat d'une sortie (1  4) du module spcifi
  un code erreur correspond  la valeur retourne par la fonction }


function TCUSB18A_Counter(NModule,Entree:integer;var Data:byte):integer;stdcall;external 'TCUSB18A.DLL';
{ Lecture du compteur de l'entre spcifie du module indiqu, le retour se fait par
  parametre dans la variable Data (8 bits),
  un code erreur correspond  la valeur retourne par la fonction }


function TCUSB18A_Config(NModule:integer;Data:Byte):integer;stdcall;external 'TCUSB18A.DLL';
{ Regle  sur le module spcifi:
  2) La validit du TOPZ bit 4  1 ou 0
  un code erreur correspond  la valeur retourne par la fonction }


function TCUSB18A_Pos(NModule:integer;var Data:Integer):integer;stdcall;external 'TCUSB18A.DLL';
{ Lecture du codeur du module indiqu, le retour se fait par parametre dans la variable Data (32 bits sign),
  un code erreur correspond  la valeur retourne par la fonction }

  
function TCUSB18A_ResetPos(NModule:integer):integer;stdcall;external 'TCUSB18A.DLL';
{ Remise  zro du codeur du module indiqu,
  un code erreur correspond  la valeur retourne par la fonction }

function TCUSB18A_AnaIn(NModule:integer;Voie: byte; var Data: smallint):integer;stdcall;external 'TCUSB18A.DLL';
{Lecture d'une voie analogique( de 1  4) du module indiqu (NModule). le retour se fait par parametre dans la variable Data (16 bits sign), La variable Data represente le nombre
de points convertisseur (ie sur 12bits).  Un code erreur correspond  la valeur retourne par la fonction }


function TCUSB18A_AnaInVolts(NModule:integer;Voie: byte; var Data: Double):integer;stdcall;external 'TCUSB18A.DLL';
{Lecture d'une voie analogique( de 1  4) du module indiqu (NModule). le retour se fait par parametre dans la variable Data (nombre flottant 64 bits sign), La variable Data represente la tension mesure en volts.
Un code erreur correspond  la valeur retourne par la fonction }


function TCUSB18A_AnaInmA(NModule:integer;Voie: byte; var Data: Double):integer;stdcall;external 'TCUSB18A.DLL';
{Lecture d'une voie analogique( de 1  4) du module indiqu (NModule). le retour se fait par parametre dans la variable Data (nombre flottant 64 bits sign), La variable Data represente le courant mesure en milli-ampres.
Un code erreur correspond  la valeur retourne par la fonction }


function TCUSB18A_AnaOut(NModule:integer; Voie: byte; Data: smallint):integer;stdcall;external 'TCUSB18A.DLL';
{Envoi sur une des sorties analogiques du module indiqu la valeur contenue dans la variable Data (16 bits sign) . Le parametre Data represente le nombre
de points convertisseur (ie sur 12bits).  Un code erreur correspond  la valeur retourne par la fonction }


function TCUSB18A_AnaOutVolts(NModule:integer; Voie: byte; Data: Double):integer;stdcall;external 'TCUSB18A.DLL';
{Envoi sur une des sorties analogiques du module indiqu la valeur contenue dans la variable Data (nombre flottant 64 bits sign) . Le parametre Data represente la tension que l'on souhaite obtenir sur la sortie.
  Un code erreur correspond  la valeur retourne par la fonction }


function TCUSB18A_WdgRun(NModule:integer):integer;stdcall;external 'TCUSB18A.DLL';
{ Arme la surveillance du chien de garde sur le module spcifi
  un code erreur correspond  la valeur retourne par la fonction }


function TCUSB18A_WdgStop(NModule:integer):integer;stdcall;external 'TCUSB18A.DLL';
{ Dsactive la surveillance du chien de garde sur le module spcifi
  un code erreur correspond  la valeur retourne par la fonction }

  
function TCUSB18A_WdgRearm(NModule:integer):integer;stdcall;external 'TCUSB18A.DLL';
{ Rearmement du chien de garde sur le module spcifi
  un code erreur correspond  la valeur retourne par la fonction }


function TCUSB18A_ResetPort(NModule:integer):integer;stdcall;external 'TCUSB18A.DLL';
{ Reinitialise le port USB du module
  un code erreur correspond  la valeur retourne par la fonction }

  
function TCUSB18A_CyclePort(NModule:integer):integer;stdcall;external 'TCUSB18A.DLL';
{ Deconnecte et reconnecte le port USB du module
  un code erreur correspond  la valeur retourne par la fonction }


function TCUSB18A_Version(NModule:integer;var Data1:Byte;var Data2:Byte):integer;stdcall;external 'TCUSB18A.DLL';
{ Lecture de la version du firmware du module indiqu et de la DLL, le retour se fait par parametre dans les variables Data1 (module) et Data2 (DLL) (8 bits non sign),
  un code erreur correspond  la valeur retourne par la fonction }

{ Fin TCUSB18A.INC }

